//---------------------------------------------------------------
//------------------Safety-Stop for steppers---------------------
//---------------------------------------------------------------
void StepperStop() {

  //disable drivers
  setUmode(0);
  delay(20);
  setVmode(0);
  delay(20);
  setWmode(0);
  delay(20);
  setXmode(0);
  delay(20);
  setYmode(0);
  delay(20);
  setZmode(0);
  delay(500);
  digitalWrite(motorPowerEnable, LOW);
}



//---------------------------------------------------------------
//------------------Enable Stepper---------------------
//---------------------------------------------------------------
void StepperEnable() {

  digitalWrite(motorPowerEnable, HIGH);
  delay(500);
  //enable drivers with ramp-down
  if (stepperUactive == true) {
    setUmode(1);
    delay(200);
  }
  else {
    setUmode(0);
    delay(20);
  }



  if (stepperVactive == true) {
    setVmode(1);
    delay(200);
  }
  else {
    setVmode(0);
    delay(20);
  }


  if (stepperWactive == true) {
    setWmode(1);
    delay(200);
  }
  else {
    setWmode(0);
    delay(20);
  }


  if (stepperXactive == true) {
    setXmode(1);
    delay(200);
  }
  else {
    setXmode(0);
    delay(20);
  }

  if (stepperYactive == true) {
    setYmode(1);
    delay(200);
  }
  else {
    setYmode(0);
    delay(20);
  }

  if (stepperZactive == true) {
    setZmode(1);
    delay(200);
  }
  else {
    setZmode(0);
    delay(20);
  }

}




//----------------------------------------------------
//------------------Set Stepper mode-----------------
//----------------------------------------------------

void setUmode(int Umode) {
  switch (Umode) {
    case 0:
      digitalWrite (Uenable, HIGH);
      break;

    case 1:
      digitalWrite (Uenable, LOW);
      setUresolution(UsetupRES);
      break;
  }
}

void setVmode(int Vmode) {
  switch (Vmode) {
    case 0:
      digitalWrite (Venable, HIGH);
      break;

    case 1:
      digitalWrite (Venable, LOW);
      setVresolution(VsetupRES);
      break;
  }
}

void setWmode(int Wmode) {
  switch (Wmode) {
    case 0:
      digitalWrite (Wenable, HIGH);
      break;

    case 1:
      digitalWrite (Wenable, LOW);
      setWresolution(WsetupRES);
      break;
  }
}

void setXmode(int Xmode) {
  switch (Xmode) {
    case 0:
      digitalWrite (Xenable, HIGH);

      break;

    case 1:
      digitalWrite (Xenable, LOW);
      setXresolution(XsetupRES);
      break;
  }
}

void setYmode(int Ymode) {
  switch (Ymode) {
    case 0:
      digitalWrite (Yenable, HIGH);

      break;

    case 1:
      digitalWrite (Yenable, LOW);
      setYresolution(YsetupRES);
      break;

  }
}
void setZmode(int Zmode) {
  switch (Zmode) {
    case 0:
      digitalWrite (Zenable, HIGH);

      break;

    case 1:
      digitalWrite (Zenable, LOW);

      setZresolution(ZsetupRES);
      break;
  }
}


//----------------------------------------------------
//------------------Set Stepper Current-----------------
//----------------------------------------------------
/*


  tmc_write(4, WRITE | REG_IHOLD_IRUN, 0x00021F1FUL); //IHOLD=100%, IRUN=100%
  tmc_write(4, WRITE | REG_IHOLD_IRUN, 0x00021F17UL); //IHOLD=31,3%, IRUN=100%


*/


//----------------------------------------------------
//------------------Set Stepper Resolution-----------------
//----------------------------------------------------

/*
  1:    1/1 spreadCycle  --> CFG1+CFG2 =GND
  2:    1/2 spreadCycle  --> CFG2 = GND
  4:    1/4 stealth      --> CFG1 = 5V(vcc)
  16:   1/16 stealth     --> open
  162:  1/16 spreadCycle --> CFG1 = GND
*/

/*
   full = 0x18008008UL
   1/2 = 0x17008008UL
   1/4 = 0x16008008UL
   1/8 = 0x15008008UL
   1/16 = 0x14008008UL
   1/32 = 0x13008008UL
   1/64 = 0x12008008UL
   1/128 = 0x11008008UL
   1/256 = 0x10008008UL
*/



void setUresolution(int Uresolution) {
  IHOLDIRUNcalc(IHOLDu, IRUNu, IHOLDDELAYall);
  delay(10);
  tmc_write(4, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);

  switch (Uresolution) {
    case 1:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 128:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 256:
      tmc_write(4, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(4, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
}

void setVresolution(int Vresolution) {
  IHOLDIRUNcalc(IHOLDv, IRUNv, IHOLDDELAYall);
  delay(10);
  tmc_write(5, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);
  switch (Vresolution) {
    case 1:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 128:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 256:
      tmc_write(5, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(5, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
}

void setWresolution(int Wresolution) {
  IHOLDIRUNcalc(IHOLDw, IRUNw, IHOLDDELAYall);
  delay(10);
  tmc_write(6, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);

  switch (Wresolution) {
    case 1:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 128:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;


    case 256:
      tmc_write(6, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(6, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
}

void setXresolution(int Xresolution) {
  IHOLDIRUNcalc(IHOLDx, IRUNx, IHOLDDELAYall);
  delay(10);
  tmc_write(1, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);


  switch (Xresolution) {
    case 1:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8

      delay(10);
      break;

    case 128:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 256:
      tmc_write(1, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(1, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
}

void setYresolution(int Yresolution) {
  IHOLDIRUNcalc(IHOLDy, IRUNy, IHOLDDELAYall);
  delay(10);
  tmc_write(2, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);

  switch (Yresolution) {
    case 1:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 128:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;


    case 256:
      tmc_write(2, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(2, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
  Serial.println("done");
}

void setZresolution(int Zresolution) {

  IHOLDIRUNcalc(IHOLDz, IRUNz, IHOLDDELAYall);
  delay(10);
  tmc_write(3, WRITE | REG_IHOLD_IRUN, IHOLDIRUNvalue); //IHOLD=0x10, IRUN=0x10
  delay(10);

  switch (Zresolution) {
    case 1:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x18008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 2:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x17008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 4:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x16008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 8:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x15008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 16:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x14008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 32:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x13008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 64:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x12008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 128:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x11008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;

    case 256:
      tmc_write(3, WRITE | REG_GCONF,      0x00000005UL); //voltage on AIN is current reference
      delay(10);
      tmc_write(3, WRITE | REG_CHOPCONF,   0x10008008UL); //native 256 microsteps, MRES=0, TBL=1=24, TOFF=8
      delay(10);
      break;
  }
}



//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveBackToStartMovie() {


  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);

  AccelStepperU.moveTo(0);
  AccelStepperV.moveTo(0);
  AccelStepperW.moveTo(0);
  AccelStepperX.moveTo(0);
  AccelStepperY.moveTo(0);
  AccelStepperZ.moveTo(0);

  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();


  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {

    moveHomeMovie = false;


    if (movieFinished == true) {
      movieFinished = false;
      startMovie = false;
      StringSend = "#movieHome_0$";
      Serial1.print(StringSend);
    }
    else {
      posii = 0;

      accellX = videoMaxMoveSpeedX / videoPointUpdateTime;
      AccelStepperX.setAcceleration(accellX);

      accellY = videoMaxMoveSpeedY / videoPointUpdateTime;
      AccelStepperY.setAcceleration(accellY);

      accellZ = videoMaxMoveSpeedZ / videoPointUpdateTime;
      AccelStepperZ.setAcceleration(accellZ);

      accellU = videoMaxMoveSpeedU / videoPointUpdateTime;
      AccelStepperU.setAcceleration(accellU);

      accellV = videoMaxMoveSpeedV / videoPointUpdateTime;
      AccelStepperV.setAcceleration(accellV);

      accellW = videoMaxMoveSpeedW / videoPointUpdateTime;
      AccelStepperW.setAcceleration(accellW);

      timedurationVid = ((float)videoPointUpdateTime) / 100;
      startMovie = true;

    }


    previousMillisVidArray = millis();

  }
}
//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveBackToStart() {

  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);

  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();

  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {
    movehome = false;
    myString = "0";
    StringSend = "#homeReached_" + myString + "$";
    Serial1.print(StringSend);
  }
}
//----------------------------------------------------
//---------------Move back to start position----------
//----------------------------------------------------

void moveToKeyframe() {


  AccelStepperU.setAcceleration(speedU / 2);
  AccelStepperV.setAcceleration(speedV / 2);
  AccelStepperW.setAcceleration(speedW / 2);
  AccelStepperX.setAcceleration(speedX / 2);
  AccelStepperY.setAcceleration(speedY / 2);
  AccelStepperZ.setAcceleration(speedZ / 2);


  AccelStepperU.run();
  AccelStepperV.run();
  AccelStepperW.run();
  AccelStepperX.run();
  AccelStepperY.run();
  AccelStepperZ.run();

  if (AccelStepperU.distanceToGo() == 0 && AccelStepperV.distanceToGo() == 0 && AccelStepperW.distanceToGo() == 0 && AccelStepperX.distanceToGo() == 0 && AccelStepperY.distanceToGo() == 0 && AccelStepperZ.distanceToGo() == 0) {
    moveKeyframe = false;

    myString = String(AccelStepperU.currentPosition());
    StringSend = "#curPosU_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperV.currentPosition());
    StringSend = "#curPosV_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperW.currentPosition());
    StringSend = "#curPosW_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperX.currentPosition());
    StringSend = "#curPosX_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperY.currentPosition());
    StringSend = "#curPosY_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = String(AccelStepperZ.currentPosition());
    StringSend = "#curPosZ_" + myString + "$";
    Serial1.print(StringSend);

    delay(40);
    myString = "0";
    StringSend = "#keyframeReached_" + myString + "$";
    Serial1.print(StringSend);
  }
}
//----------------------------------------------------
//---------------Speed settings----------
//----------------------------------------------------


void setMaxSpeedSteppers() {
  AccelStepperU.setMaxSpeed(speedU);
  AccelStepperV.setMaxSpeed(speedV);
  AccelStepperW.setMaxSpeed(speedW);
  AccelStepperX.setMaxSpeed(speedX);
  AccelStepperY.setMaxSpeed(speedY);
  AccelStepperZ.setMaxSpeed(speedZ);
}

void setSpeedFast() {
  AccelStepperU.setMaxSpeed(speedUsetFast);
  AccelStepperV.setMaxSpeed(speedVsetFast);
  AccelStepperW.setMaxSpeed(speedWsetFast);
  AccelStepperX.setMaxSpeed(speedXsetFast);
  AccelStepperY.setMaxSpeed(speedYsetFast);
  AccelStepperZ.setMaxSpeed(speedZsetFast);
}

void setSpeedSlow() {
  AccelStepperU.setMaxSpeed(speedUsetSlow);
  AccelStepperV.setMaxSpeed(speedVsetSlow);
  AccelStepperW.setMaxSpeed(speedWsetSlow);
  AccelStepperX.setMaxSpeed(speedXsetSlow);
  AccelStepperY.setMaxSpeed(speedYsetSlow);
  AccelStepperZ.setMaxSpeed(speedZsetSlow);
}
